<?php

require_once 'ModalAdministrable.php';
require_once 'lib/customlib/datatable/dataTableDB.php';

/**
 * Class ModalAdministrableCtrl
 */
class ModalAdministrableCtrl {

    static public function requestAsyncAction($action) {

        switch ($action) {

            case ActionDispatcher::entity_action_getInstance:
                $_ret = self::getInstantiated();
                $_ret = $_ret->getJsonEncoded();
                break;

            case ActionDispatcher::entity_action_update:
                $_postObj = Secure_PostGet_Vars::get_JsonObject_Post();
                $_ret = self::Persist($_postObj);
                $_ret = $_ret->getJsonEncoded();
                break;
        }

        print $_ret;
    }

    /**
     * @return statusResponse
     */
    static public function getInstantiated() {

        $_entity = ModalAdministrable::get();
        if ($_entity) {

            $dataArray = array('dvm'=>array("dvme"=>$_entity->toArray(),'config'=>array()));

            $_ret = statusResponse::getInstanceOk();
            $_ret->setData($dataArray);
        } else {
            $_ret = statusResponse::getInstanceFromTableMsgCode(msgTable::ERROR_ENTITY_INSTANTIATE_NOTFOUND);
        }

        return $_ret;

    }

    /**
     * @param $jsonObject
     * @return statusResponse
     */
    static public function Persist($jsonObject){
        $_entity = ModalAdministrable::getInstantiatedFromPostJsonObject($jsonObject->object_data);

        $_persistRet = $_entity->Persist();
	FB::info($_persistRet);

        if($_persistRet->isOk()){
            $_ret = statusResponse::getInstanceOk();

            $_entity = ModalAdministrable::getInstance();
            if($_entity)
                $_ret->setData($_entity->toArray());
        }else{
            $_ret = statusResponse::getInstanceFromTableMsgCode(msgTable::ERROR_ENTITY_UPDATE_FAIL);
            $_ret->setDebugInfo($_persistRet->getDebugInfo());
        }

        return $_ret;
    }


}
