<?php
/**
 * Created by PhpStorm.
 * User: usuario1
 * Date: 13/10/2017
 * Time: 10:44 AM
 */

require_once 'lib/config/appConfig.class.php';
require_once 'lib/customlib/database/json/JSON.class.php';

class dataTableStructureJson extends JSON{

    private $entity;

    function __construct($entity) {
        $this->entity = strtolower($entity);
    }

    protected function getFileName() {
        return $this->entity . ".json";
    }

    protected function getJsonFile() {
        $_filename = appConfig::DATATABLE_STRUCTURE_DATA_JSON . $this->getFileName();
        $_ret = self::open($_filename);
        if (!$_ret)
            throw new Exception("No se pudo encontrar el archivo de structura de base datos ($_filename)");
        return $_ret;
    }

    /**
     *
     * @param String $id
     * @return \stdClass|boolean
     */
    static public function getStructure($entity) {
        $_obj = new dataTableStructureJson($entity);

        $_ret = $_obj->getJsonFile();

        return $_ret;
    }

}