<?php

abstract class  DbConfigData {

    protected static $oracleType = "oci8";
    protected static $mysqlType = "mysql";

    /**
     * php date format for RDBMS. How to format the date to insert or updates in RDBMS
     */
    public static $dateFormat = "Y-m-d";
    public static $dateTimeFormat = "Y-m-d H:i:s";

    // oracle version;
    // public static $dateNullValue="0000-00-00 00:00:00";
    // public static $dateNullValue=null;
    public static $dateTimeNullValue = "0000-00-00 00:00:00";
    public static $dateNullValue = "0000-00-00";


    /**
     *  RDBMS default date format. Database returns format in the following format
     */
    public static $RDBMS_DateFormat = "%Y-%m-%d";
    public static $RDBMS_DateTimeFormat = "%Y-%m-%d %H:%i:%s";

    /**
     * DB Charset Encoding
     */
    const DB_CHARSET_ENCODING_ENABLE = TRUE;
    public static $DBCharsetEncoding = "ISO-8859-1";
    public static $PHPCharsetEncoding = "UTF-8";

    /**
     * Database connect params
     */
    protected static $dsn_mysql = array(
        'phptype' => 'mysql',
        'dbsyntax' => 'mysql',
        'username' => 'website_user',
        'password' => '3rPqRQF7CFDuvGk2',
        'protocol' => 'tcp/ip',
        'hostspec' => 'localhost',
        'port' => '3306',
        'socket' => false,
        'database' => 'liderar',
        'mode' => false,
        'charset' => 'utf8'
    );

    protected static $options = array(
        'debug' => 9
        //'result_buffering' => false,
    );

    public static function getOptions() {
        return self::$options;
    }

    public static function getDSN() {
        return self::$dsn_mysql;
    }
}

?>
